/**
 * @file
 */
#ifndef RB_CLASS_H
#define RB_CLASS_H


#include <sigly.h>
#include <RedBox/State.h>
#include <RedBox/KeySignalData.h>
#include <RedBox/PointerButtonSignalData.h>
#include <RedBox/PointerMoveSignalData.h>
#include <RedBox/Sprite.h>
#include <RedBox/Timer.h>
#include <RedBox/SpriteEmitter.h>

/**
 * Play state.
 */
class PlayState : public RedBox::State {
public:
	PlayState();
	void onKeyPress(RedBox::KeySignalData data);
	void onKeyHold(RedBox::KeySignalData data);
	void onKeyRelease(RedBox::KeySignalData data);
	void onMousePress(RedBox::PointerButtonSignalData data);
	void onMouseMove(RedBox::PointerMoveSignalData data);
	void onMouseRelease(RedBox::PointerButtonSignalData data);
	void onMouseHold(RedBox::PointerButtonSignalData data);
	void update();
	void render();
	void emitExplosion(float x, float y);
	void randomExplosion();
private:
	static const float JUMP_VEL = -1200.0f;
	static const float MOVE_ACCEL = 1200.0f;
	unsigned int nbUdpates;
	double lastSecond;
	unsigned int nbRenders;
	double lastSecond2;
	RedBox::Sprite* shape;
	RedBox::Sprite* floor;
	RedBox::Timer exploder;
};

#endif
