
/** 
 * @defgroup Display Display
 * @brief Display related classes (sprite, drawer, camera, etc.)
 */

/** 
 * @defgroup GraphicDrivers GraphicDrivers
 * @ingroup Display
 * @brief Graphics backend (opengl directX or flash driver)
 */

/**
 * @defgroup Math Math
 * @brief Classes that have mathematical purposes.
 */

/**
 * @defgroup Helper Helper
 * @brief Classes used for miscellaneous utilities.
 */

/**
 * @defgroup Physics Physics
 * @brief Classes used in the physics engine.
 */

/**
 * @defgroup TextDisplay
 * @ingroup Display
 */

/**
 * @defgroup Audio Audio
 * @brief Classes used for the audio engine.
 */
/**
 * @defgroup Events Events
 * @brief Classes used for the event system.
 */

/**
 * @defgroup Input Input
 * @brief Classes related to player input.
 */

#include <RedBox/RedBoxEngine.h>
#include <RedBox/ResourceManager.h>
#include <RedBox/ResourcePathHandler.h>
#include <RedBox/Sprite.h>